#pragma once
#include "util.h"
#include <stdio.h>
#include <sys/types.h>

#include "blist.h"

enum blist_command {
  USER,
  LIST,
  TASK,
};

struct blist_app {
  enum blist_command cmd;
  void *cmd_ctx;
  int error;
  blist_logging_ctx *log_ctx;
  blist *handle;
  char *config;
};
typedef struct blist_app blist_app;

blist_app *blist_app_init(char *db);
void blist_app_deinit(blist_app *app);

enum blist_user_command { USER_GET, USER_CREATE, USER_DELETE };
struct blist_user_context {
  enum blist_user_command cmd;
};
typedef struct blist_user_context blist_user_context;

blist_user_context *blist_user_context_init(void);
void blist_user_context_deinit(blist_user_context *ctx);

enum blist_list_command {
  LIST_ADD,
  LIST_EDIT,
  LIST_GET,
  LIST_DELETE,
};
struct blist_list_context {
  enum blist_list_command cmd;
  char *name;
  char *desc;
  char **stages;
  size_t stages_len;
  char *preset;
};
typedef struct blist_list_context blist_list_context;

blist_list_context *blist_list_context_init(void);
blist_list_context *blist_list_context_get_by_id(blist_list_context *ctx,
                                                 u_int id);
void blist_list_context_deinit(blist_list_context *ctx);

enum blist_task_command {
  TASK_ADD,
  TASK_EDIT,
  TASK_GET,
  TASK_DELETE,
};
struct blist_task_context {
  enum blist_task_command cmd;
  char *list;
  char *name;
  char *desc;
  char *stage;
};
typedef struct blist_task_context blist_task_context;

blist_task_context *blist_task_context_init(void);
void blist_task_context_deinit(blist_task_context *ctx);