#include "util.h"

#include <stdlib.h>

blist_app *blist_app_init(char *db) {
  blist_app *app = malloc(sizeof(blist_app));
  app->cmd = 0;
  app->cmd_ctx = 0;
  app->error = 0;
  app->config = NULL;
  app->log_ctx = malloc(sizeof(blist_logging_ctx));
  app->log_ctx->log_level = BLIST_LOG_DEBUG;
  app->log_ctx->log_target = stderr;
  app->handle = blist_init(db);
  app->handle->log_ctx->log_level = app->log_ctx->log_level;
  app->handle->log_ctx->log_target = app->log_ctx->log_target;
  return app;
}
void blist_app_deinit(blist_app *ctx) {
  if (ctx->config)
    free(ctx->config);
  if (ctx->handle)
    blist_deinit(ctx->handle);
  else if (ctx->log_ctx)
    fclose(ctx->log_ctx->log_target);
  free(ctx->log_ctx);
  free(ctx);
}

blist_user_context *blist_user_context_init() {
  blist_user_context *ctx = malloc(sizeof(blist_user_context));
  ctx->cmd = -1;
  return ctx;
}
void blist_user_context_deinit(blist_user_context *ctx) {
  free(ctx);
  ctx = NULL;
}

blist_list_context *blist_list_context_init() {
  blist_list_context *ctx = malloc(sizeof(blist_list_context));
  ctx->cmd = -1;
  ctx->name = NULL;
  ctx->desc = NULL;
  ctx->stages = NULL;
  ctx->stages_len = 0;
  ctx->preset = NULL;
  return ctx;
}
void blist_list_context_deinit(blist_list_context *ctx) {
  if (ctx->name)
    free(ctx->name);
  if (ctx->desc)
    free(ctx->desc);
  if (ctx->preset)
    free(ctx->preset);
  if (ctx->stages) {
    int i = 0;
    for (; i < ctx->stages_len; i++)
      free(ctx->stages[i]);
    free(ctx->stages);
  }
  free(ctx);
  ctx = NULL;
}

blist_task_context *blist_task_context_init() {
  blist_task_context *ctx = malloc(sizeof(blist_task_context));
  ctx->cmd = -1;
  ctx->name = NULL;
  ctx->desc = NULL;
  ctx->list = NULL;
  ctx->stage = NULL;
  return ctx;
}
void blist_task_context_deinit(blist_task_context *ctx) {
  if (ctx->name)
    free(ctx->name);
  if (ctx->list)
    free(ctx->list);
  if (ctx->stage)
    free(ctx->stage);
  free(ctx);
  ctx = NULL;
}
